/*
this file defines necessry data struct to record information about attached network to other nodes, 
*/
#include "types.h"

//represent information about attached networks
struct attached_gw_info
{
	olsr_ip_addr gw;
	olsr_ip_addr net;
	olsr_ip_addr mask;
	struct timeval attached_gw_timer;
	struct attached_gw_info * next;
	struct attached_gw_info * prev;
};

//represent information about local attached networks or info stored in tc message.
struct gw_info
{
	olsr_ip_addr gw;
	olsr_ip_addr net;
	olsr_ip_addr mask;
	struct attached_gw_info * next;
};

struct list_attached_gw_info
{
	struct attached_gw_info * first;
	struct attached_gw_info * last;
};
/*
struct net_addr
{
  olsr_ip_addr net_addr;
  byte mask_num;
 // struct tc_gw next;
};

struct net_list
{
        struct net_addr AN_net_adddr;
        olsr_u16_t dist;
        struct net_list * next;
};

struct attached_net_info
{
        olsr_u32_t attached_net_hash;
		struct timeval attached_net_timer;
        olsr_ip_addr AN_gw_iface_addr;
		struct net_list * attached_net_list;
        
};

//structure used to store information in tc packet
struct attached_net_info_tc_msg
{
    olsr_ip_addr AN_gw_iface_addr;
	struct net_list * attached_net_list;
	struct attached_net_info_tc_msg * next;
        
};

struct attached_net_entry
{
	struct attached_net_info att_net_infos;
	struct attached_net_info * att_net_forw;
	struct attached_net_info * att_net_back;
};

struct attached_net_hash
{
        struct attached_net_entry * attached_net_forw;
        struct attached_net_entry * attached_net_back;
};
*/